#!/usr/local/bin/perl

package Passwd;
use Moose;
use Moose::Util::TypeConstraints;
use Path::Class;

subtype 'File'
    => as 'Object',
    => where { $_->isa('Path::Class::File') };

coerce 'File'
    => from 'Str',
    => via { Path::Class::File->new($_) };

has file => (
    is       => 'ro',
    isa      => 'File',
    coerce   => 1,
    required => 1,
    handles  => { cat => 'slurp' },
);

package main;

my $passwd = Passwd->new(file => '/etc/passwd');
print $passwd->cat;
